Subject: [secdir] Secdir review of draft-josefsson-pkix-textual

From: Magnus Nyström <[email-masked]>
Date: Tue, 2 Dec 2014 15:19:01 +0100

I have reviewed this document as part of the security directorate's ongoing
effort to review all IETF documents being processed by the IESG. These
comments were written primarily for the benefit of the security area
directors. Document editors and WG chairs should treat these comments just
like any other last call comments.

This memo documents textual encodings of various well-established
PKI-related data structures and formats. The document is intended to be
published as a Standards-Track RFC.
Comments and suggestions:

Section 5.1:
 - For clarity and common keyword usage, suggest replacing "The encoded
data MUST be a BER (DER strongly preferred) encoded ASN.1..." with: "The
encoded data MUST be BER and SHOULD be a DER encoded ASN.1..." (In fact
this comment goes for all places where you have text like "MUST be a BER
(DER [strongly] preferred" - better to use established RFC 2119 language).
- I wonder why you state "Parsers are NOT RECOMMENDED to treat "X509
CERTIFICATE" or "X.509 CERTIFICATE" as equivalent to "CERTIFICATE", but a
valid exception may be for backwards compatibility (potentially together
with a warning)" since to my knowledge, they all refer to the same
structure and in the spirit of "strict in issuance, generous in receipt",
it would seem to be better to state: ""Parsers MAY treat ... as equivalent
to "CERTIFICATE" " ?
- I also wonder about the warning above since if the structure indeed does
parse as a certificate, what value would the warning bring (and to whom)?

Section 5.3:
I disagree with the deprecation of .cer in favor of .crt. The .cer
convention is used broadly. I would suggest updating the text to recommend
use of .crt OR .cer. Better yet, remove the section, since this document
specifically is about textual encodings and not file extension naming and
you do not discuss extension naming elsewhere.

Section 6:
Same comments as for Section 5.1 above, but for CRLs...

Section 7:
Same comment as my first for Section 5.1. I note that you have the same
language with regards to parser flexibility here that I have suggested for
Section 5.1 and Section 6.

Security Considerations:
No particular comments.

-- Magnus

---

From: Yoav Nir <[email-masked]>
Date: Wed, 3 Dec 2014 14:01:44 +0200

Hi Magnus

[adding IESG]

See below

> On Dec 2, 2014, at 4:19 PM, Magnus Nyström <[email-masked]> wrote:
> 
> I have reviewed this document as part of the security directorate's ongoing effort to review all IETF documents being processed by the IESG. These comments were written primarily for the benefit of the security area directors. Document editors and WG chairs should treat these comments just like any other last call comments.
> 
> This memo documents textual encodings of various well-established PKI-related data structures and formats. The document is intended to be published as a Standards-Track RFC.
>  - For clarity and common keyword usage, suggest replacing "The encoded data MUST be a BER (DER strongly preferred) encoded ASN.1..." with: "The encoded data MUST be BER and SHOULD be a DER encoded ASN.1..." (In fact this comment goes for all places where you have text like "MUST be a BER (DER [strongly] preferred" - better to use established RFC 2119 language).

In general (this is not a hard and fast rule) a SHOULD should come with an explanation of when it isn’t needed. Unless we have a good case for saying when it’s OK to use non-DER, I’d rather stick with the non-2119 “prefer”.

> - I wonder why you state "Parsers are NOT RECOMMENDED to treat "X509 CERTIFICATE" or "X.509 CERTIFICATE" as equivalent to "CERTIFICATE", but a valid exception may be for backwards compatibility (potentially together with a warning)" since to my knowledge, they all refer to the same structure and in the spirit of "strict in issuance, generous in receipt", it would seem to be better to state: ""Parsers MAY treat ... as equivalent to "CERTIFICATE" “ ?

I’ll leave this to the authors to answer.

> - I also wonder about the warning above since if the structure indeed does parse as a certificate, what value would the warning bring (and to whom)?

ditto

> Section 5.3:
> I disagree with the deprecation of .cer in favor of .crt. The .cer convention is used broadly. I would suggest updating the text to recommend use of .crt OR .cer. Better yet, remove the section, since this document specifically is about textual encodings and not file extension naming and you do not discuss extension naming elsewhere.

IDK. These formats are used mostly in files, and despite twenty years of attempts, classification by extension is still the norm. .cer files often contain either BER or a textual representation, while .crt tends to mostly be textual. I don’t see why we shouldn’t document this convention.

> Same comment as my first for Section 5.1. I note that you have the same language with regards to parser flexibility here that I have suggested for Section 5.1 and Section 6.
> 
> Security Considerations:
> No particular comments.
>  
> — Magnus

Yoav

---

From: <[email-masked]>
Date: Thu, 11 Dec 2014 16:26:34 +0000

Thanks Yoav,

I don’t want to create a long thread here, but just to note my thinking on the two aspects you comment on:

On the first one, IMHO we shouldn’t introduce new language in addition to 2119. If there is a “good case” for saying preferred, then I also think there is a good case for saying “SHOULD.”

On the .cer and .crt, I maintain that the document should stick to what its purpose is, which is “textual encodings of the Public-Key Infrastructure X.509 (PKIX), Public-Key Cryptography Standards (PKCS), and Cryptographic Message Syntax (CMS)”. Introducing deprecations for file extensions seems not only to be far away from that but also without thought-through consequences.

Sent from Windows Mail

From: Yoav Nir
Sent: ‎Wednesday‎, ‎3‎ ‎December‎, ‎2014 ‎04‎:‎01
To: Magnus Nyström
Cc: [email-masked], [email-masked], The IESG

Hi Magnus

[adding IESG]

See below

Section 5.1:

ditto

Section 5.3:

Section 6:

Section 7:

Security Considerations:

No particular comments.

— Magnus

Yoav